<template>
  <div class="py-2">
    <h5 class="text-muted mb-2">Checklist</h5>
    <div>
      <todo-item
        v-for="(todo, index) in todos"
        :todo="todo"
        :key="index"
        @update="updateTodo"
        @delete="deleteTodo"
      />
      <span
        type="button"
        class="add-button text-primary mt-2"
        @click="createTodo"
      >
        <app-icon icon="plus" />
      </span>
    </div>
  </div>
</template>

<script lang="ts">
import { v4 as uuidV4 } from "uuid";
import { LocalDatabase, Todo } from "@/core/database";
import { TodoRepository } from "@/core/repositories";
import { defineComponent } from "vue";
import TodoItem from "./Todo.vue";
import { SubSink } from "subsink";

export default defineComponent({
  components: { TodoItem },
  props: {
    cardId: {
      type: String,
      required: true,
    },
  },
  created() {
    LocalDatabase.getInstance().then(
      (db) => (this.todoRepository = TodoRepository.getInstance(db))
    );
  },
  watch: {
    async cardId() {
      const todoObservable = await this.todoRepository.watchAllItems(
        "cardId",
        this.cardId
      );
      this.subSink.sink = todoObservable.subscribe((todos) => {
        if (todos) {
          this.todos = todos;
        }
      });
    },
  },
  data() {
    return {
      todoRepository: {} as TodoRepository,
      todos: [] as Todo[],
      subSink: new SubSink(),
    };
  },
  methods: {
    async createTodo() {
      try {
        const newTodo = new Todo(uuidV4(), "Todo Item", this.cardId, false);
        await this.todoRepository.insertItem(newTodo);
      } catch (error) {
        console.log(error);
      }
    },
    async updateTodo(updatedTodo: Todo) {
      try {
        await this.todoRepository.updateItem(updatedTodo);
      } catch (error) {
        console.log(error);
      }
    },
    async deleteTodo(todoToDelete: Todo) {
      try {
        await this.todoRepository.deleteItem(todoToDelete);
      } catch (error) {
        console.log(error);
      }
    },
  },
  unmounted() {
    this.subSink.unsubscribe();
  },
});
</script>

<style scoped>
.add-buttton {
  height: 1.5rem;
  width: 1.5rem;
  transition: transform ease-in 200ms;
}
.add-buttton:hover {
  transform: scale(1.2);
}
</style>
